<?node_include("i18n"); ?>
var edit_selected = false;
var menu_clicked = false;
var cn3_document_changed = false;
var cn3_url_on_save = false;
var curr_part = '';
<? /* cn3_curr_tag_id is set when a tag part is selected. the id is the index of the tag found in cn3_tags */ ?>
var cn3_curr_tag_id = null;
var curr_element;
var cn3_tags = new Array();
var cn3_parts = new Array();
var cn3_childable = new Array();
var cn3_text_range;
var node_stag, node_page_id, node_editable;
var backparam;
var liveedit_stripwordpaste = '<?=$FEATURE["liveedit_stripwordpaste"];?>';
var feature_advanced_word_paste = "<?=$FEATURE["advanced_word_paste"];?>";
var gtx_liveedit_p_nodeids = '<?=$FEATURE['liveedit_p_nodeids'];?>'.split(',');
var gtx_liveedit_tidy = '<?=$FEATURE['liveedit_tidy'];?>'.split(',');


/**
 * Stores the HTML code that should be edited in tinyMCE
 */
var gtx_tableHtml;
/**
 * Stores the currently edited table as dom element
 */
var gtx_table; 
/**
 * true if the tinyMCE action is creating a table, false if otherwise
 */
var gtx_createTable = true;
/**
 * save tags which have been extracted for popup table editing in an array
 */
var gtx_extractedTags = new Array();
/**
 * save tags which have been extracted for word cleanup in an array
 */
var gtx_extractedTidyMasked = new Array();

<? /* //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// *
    *  Javascript functions to provide abstract interface for specific browser implementation are provided here 
    */
?>

function cn3_getSelection() {
	if (document.selection) {
	    return document.selection;
	} else {
	    return window.getSelection();
	}
}

function cn3_getSelectionRange() {
	if (document.selection) {
	    return document.selection.createRange();
	} else {
	    return window.getSelection().getRangeAt(0);
	}
}

function cn3_setActive(el) {
    if (el.setActive) {
	el.setActive();
    } else {
	el.focus();
    }
}

function cn3_getInnerHTML(e) {
	// fix unwanted attributes sizcache and sizset
	var obj = $(e);
	obj.find("[sizset]").removeAttr("sizset");
	obj.find("[sizcache]").removeAttr("sizcache");

    if ( e.innerHTML ) {
	return e.innerHTML;
    }

    var txt = "";

    if ( !e.hasChildNodes() ) {
	return "";
    }
    e = e.firstChild;
    while ( e != null ) {

	switch (e.nodeType) {
	    // Element
 	    case 1:
		var name = e.nodeName.toLowerCase();
		
	     	txt += "<" + e.nodeName;
		
		// create attributes
		var i;
		for (i = 0; i < e.attributes.length; i++) {
		    txt += " " + e.attributes[i].nodeName + "=\"";
		    // TODO escape attributes with html-chars too?
		    txt += e.attributes[i].nodeValue.replace(/"/g,"\\\"");
		    txt += "\"";
		}
		
		if ( name == "br" ) { txt += "/"; }
		txt += ">";

		if ( name == "area" || name == "base" || name == "basefont" || name == "bgsound" || name == "br" || 
			name == "col" || name == "embed" || name == "frame" || name == "hr" || name == "img" || 
			name == "input" || name == "link" || name == "meta" || name == "param" || name == "spacer" ||
			name == "wbr" ) {
		    break;
		}
		
		if ( name == "pre" || name == "textarea" ) { txt += "\r\n"; }

		txt += cn3_getInnerHTML( e );
		
		txt += "</" + e.nodeName + ">";

	        break;	    
	    // text, cdata
	    case 3:
	    case 4:
		// escape &,<,>,"
		txt += e.data.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;");
	    	break;
	    // Processing instruction
	    case 7:
		txt += "<\?" + e.target + " " + e.data + ">";
		break;
	    // comment
	    case 8:
		txt += "<!--" + e.data + "-->";
		break;
	}
	
	e = e.nextSibling;
    }
    return txt;
}

function cn3_setInnerHTML( el, html ) {
    el.innerHTML = html;
}

function cn3_getInnerText( el ) {
	if ( el.innerText ) {
	    return el.innerText;
	} else if ( el.textContent ) {
	    return el.textContent;
	}
}

function cn3_getKeyCode( event )
{
    if ( window.event )
	return window.event.keyCode;
    else
	return event.keyCode;
}

function cn3_restore_range(range) {
    if ( window.getSelection ) {
	var sel = window.getSelection();
	sel.removeAllRanges();
	sel.addRange(range);
    }
}

function cn3_createRange(el) {
	if (document.createRange) {
		var range = document.createRange();
		range.selectNode(el);
		return range;
	} else {
		
	}
}

function cn3_getRangeText(range) {
	if ( range.text || range.text == "" ) {
	    return range.text;
	} else if ( range.toString ) {
	    return range.toString();
	} else {
		return range;
	}
}

function cn3_getRangeHTML(range) {
    if ( document.all ) {
	return range.htmlText;
    } else {
	var content = range.cloneContents();
	return cn3_getInnerHTML(content);
    }
}

function cn3_execCommand(cmd, value, range) {
    if (document.all) {
	if ( !range ) {
	    range = document;
	}
	range.execCommand(cmd, null, value);
    } else {
        if (range) {
    	    cn3_restore_range(range);
        }
        document.execCommand(cmd, false, value);
    }
}

function cn3_pasteHTML(range, html) {
    if ( range.pasteHTML ) {
	range.pasteHTML(html);
	range.select();    
    } else {
	tmp = document.createElement("span");
	tmp.innerHTML = html;

	range.deleteContents();
	range.insertNode(tmp);
<? /*
	var childs = tmp.childNodes;
	for (var i = 0; i < childs.length; i++) {
	    if ( childs[i] ) {
	    	range.insertNode(childs[i]);
		range.setStartAfter(childs[i]);
	    alert(childs[i] + ";" + childs[i].innerHTML);
	    }
	}
*/ ?>
    }
}

function cn3_insertBreak(range) {
    if ( range.pasteHTML ) {
	range.pasteHTML( '<br />' );
	range.select();
    } else {
	var br = document.createElement("br");
	range.deleteContents();
	range.insertNode(br);
	range.setStartAfter(br);
    }
}

function cn3_getClipboardContent() {
    var tmp;
    var tmpRange;
    
    tmp = document.getElementById("tmpPaster");
    cn3_setInnerHTML(tmp, "");
    
    tmpRange = cn3_createRange(tmp);
    cn3_setActive(tmp);

<?  /* For some reasons passing a range here does not work */ ?>
    cn3_execCommand("Paste", false, false);
    
    var child = tmp.firstChild;
    if ( !document.all && child && child.nodeName.toUpperCase() == "H3" && tmp.childNodes.length == 1) {
	tmp.removeChild(child);
	tmp.innerHTML = "<span>" + child.innerHTML + "</span>";
    }
  
    return cn3_getInnerHTML(tmp);
}

<? /* //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// *
    *  Wrapper functions which work on the current selection, used as interface for contextmenu (work on selection stored in cn3_text_range) 
    */ 
?>

/**
 * Exec a command 
 **/
function cn3_range_execCommand(cmd, value) {
    cn3_execCommand(cmd, value, cn3_text_range);
}

/**
 * Paste html code into a range.
 **/
function cn3_range_pasteHTML(html) {
    cn3_pasteHTML(cn3_text_range, html);
}

function cn3_range_removeFormat() {
<? if ( $FEATURE["liveedit_smartremoveformat"] ) { ?>
    var html = cn3_getRangeHTML( cn3_text_range );
    html = smartStripTags(html, true);
    cn3_range_pasteHTML(html);
<? } else { ?>
    cn3_range_execCommand("RemoveFormat");
<? } ?>
}

<? /* //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// *
    *  Core liveedit functions. Beyond this line only standard javascript functions and calls to wrapper functions 
    *  are used, no browser dependend code!! 
    */ 
?>

function unclicked() {
     menu_clicked = false;
}

// helper function called from setTimeout
function unselect() {
	edit_selected = false;
}

// Blockkselection functions
function cn3_edit(tag, part) {
	var i;
	var j;
	var t;
	var p;
	var ti;
	var xyz;

	// add livespellcheck icon
// temporarily removed livespellcheck icon
//	if (undefined !== livespellcheck && livespellcheck) {
//		GTXSpellCheck.activate(tag);	
//	}

	//Return if double-clicked on the content that we are already editing
	if ( part == '' )
	{
		var nr = 1;
		p = null;
		while ( nr < 1000 && !p ) {
			p = document.getElementById('p_' + tag + '_' + nr);
			part = nr;
			nr++;
		}
			
	}
	else
	{
		p = document.getElementById('p_' + tag + '_' + part);
	}
	if (p) {
		xyz = p.contentEditable;
		if ( String(xyz).toLowerCase() == 'true' )
		{
			if ( window.event ) window.event.cancelBubble = true;
			return;
		}
	}
	// Document is edited
	cn3_document_changed = true;
	
	if (!edit_selected) {

		setTimeout('unselect()', 100);
		edit_selected = true;

		// unselect all tags and parts
		if (cn3_tags)
		for(i=0; i <= cn3_tags.length; i++) {
		        if( cn3_tags[i] == tag ) cn3_curr_tag_id = i;
			if (document.getElementById('t_' + cn3_tags[i])) {
				t = document.getElementById('t_' + cn3_tags[i]);
				t.className = 'lock';
				t.contentEditable = false;
				if (cn3_tags[i] == tag) ti = i;
			}
			if (cn3_parts[i])
			for(j=0; j <= cn3_parts[i].length; j++) {
				if (document.getElementById('p_' + cn3_tags[i] + '_' + cn3_parts[i][j])) {
					p = document.getElementById('p_' + cn3_tags[i] + '_' + cn3_parts[i][j]);
					p.className = 'lock_part';
					p.contentEditable = false;
				}
			}
		}

		// select current tag
		if (document.getElementById('t_' + tag)) {
			t = document.getElementById('t_' + tag);
			t.className = 'edit';
		}
		// No part has been selected, so select first one
		//if (!part && cn3_parts[ti].length > 0) part = cn3_parts[ti][0];

		// select current part
		curr_part = '';
		if (document.getElementById('p_' + tag + '_' + part)) {
			p = document.getElementById('p_' + tag + '_' + part);
			p.className = 'edit_part';
			p.contentEditable = true;
			cn3_setActive(p);
			var range = cn3_getSelectionRange();
			if ( cn3_getInnerHTML(p) == "&nbsp;&nbsp;" )
			{
			    if ( range.findText ) {
				range.findText( "  " );
				range.select();
			    } else if ( range.selectNode ) {
				range.selectNode(p);
			    }
			}
			else if ( window.event )
			{
				// try-catch-statement added by LT, see rt#23096 and rt#24897
				try {
					range.moveToPoint( window.event.x, window.event.y );
					range.select();
				} catch (error) {
					// do nothing!
				}
			}
			else //not triggered by an event - place the caret at the beginning
			{
				if ( document.all ) p.focus();
			}
			curr_part = p.id;
			curr_element = p;
		}
	}
}



function cn3_save_tags(save_script, windowsizeX, windowsizeY, target ) {
	var e;
	var h;
	var scrollbars;
	var saveText;
	var width = 200, height = 40;
	if ( windowsizeX )
		width = windowsizeX;
	if ( windowsizeY )
		height = windowsizeY;
	if ( !windowsizeX && !windowsizeY && !target )
	{
		scrollbars = 'no';
	}
	else
		scrollbars = 'yes';
		
	//make cool saving-text
	saveText = '<HTML><HEAD>';
	saveText += '<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">';
	saveText += '</HEAD>';
	saveText +=  '<body style="background-color:#F0F5F9" <?=($DEBUG["tag_save"]?"":'onblur="self.focus();"')?>>';
	saveText += '<center><font face="Arial,Helvetica"><?=i18n("Please wait")?>...</font></center>\n';	
		
	// Prepare Form
	var form_html = '<form id="cn3_save_form" action="' + save_script + '" method="POST" enctype="multipart/form-data">\n';
	for (i=0; i<cn3_tags.length; i++) {
		for (j=0; j<cn3_parts[i].length; j++) {
			e = document.getElementById('p_' + cn3_tags[i] + '_' + cn3_parts[i][j]);
			if ( e )
			{ 
				if (!debug_tag_save) {
					form_html += '<input type=hidden id="part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']" name="part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']" value="">';
				} else {
					form_html += '<br>tag (' + cn3_tags[i] + ') part (' + cn3_parts[i][j] + ')  Varname (part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + '])<br>\n';
					form_html += '<textarea id="part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']" name="part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']" rows=5 cols=90> </textarea>\n';
				}
			}
		}
	}
	form_html += '<input type=submit value=Gooooooo></form>\n';
	
	if ( target == '' || !target ) {
		target = '_blank';
	}
	if (!debug_tag_save) {
		var save_win = window.open('', target,'dependent=yes,status=no,scrollbars='+scrollbars+',width='+width+',height='+height+',resizable=yes');
	} else {
		var save_win = window.open('', target,'dependent=yes,status=no,scrollbars=yes,width='+width+',height='+height+',resizable=yes');
	}
	save_win.document.open();
	save_win.document.write(saveText);
	if (!debug_tag_save) {
		save_win.document.write('<div id=cn3_save_layer style="position:absolute; visibility:hidden">' + form_html + '</div>');
	} else {
		//save_win.document.write('<div id=cn3_save_layer style="position:absolute; visibility:visible">' + form_html + '</div>\n');
		save_win.document.write(form_html);
	}
	save_win.document.write('</body></HTML>');
	save_win.document.close();
	
	<?
	//ME: comment to those as brainless as myself:
	//those loop is there for a reason: it escapes html correctly...
	?>
  	for (i=0; i<cn3_tags.length; i++) {
             for (j=0; j<cn3_parts[i].length; j++) {
                   e = document.getElementById('p_' + cn3_tags[i] + '_' + cn3_parts[i][j]);
                   //if this elements exists
                   if (save_win.document.getElementById('part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']')) {
                           h = save_win.document.getElementById('part[' + cn3_tags[i] + '][' + cn3_parts[i][j] + ']');
                           if ( e ) //if this element does not exist, remove it from the node-tree
                           {
				<? if ( $FEATURE["UTF8"] ) { ?>
				    var myValue = cn3_getInnerHTML( e );
				<? } else { ?>
				    var myValue = escape( cn3_getInnerHTML( e ) );
				<?}?>
				    
				<? /* Mega grausig hack to make firefox-breaks to IE-breaks so that buggy break-replace-hacks work 
				      Replace helper span tags too. */ ?>
				if (!document.all) {
				    myValue = myValue.replace(/<br>/g, "<BR>");
				    myValue = myValue.replace(/<\/?span>/gi, "");
				}
				
                                <? if ($FEATURE["advanced_word_paste"]) { ?>
                                // since FEATURE["advanced_word_paste"] is enabled we do some replacements to preserve Tocs
                                h.value = myValue.replace(/http[^#]+(#_Toc\d+)/gi, "$1");
                                <? } else { ?>
                                h.value = myValue;
                                <? } ?>
                           }
                   }
             }
    	}	
	
	var f = save_win.document.getElementById('cn3_save_form');
	if (!debug_tag_save) f.submit();
	// HP 2007-01-29: Disabled because if user changes one tag, clicks 'Live Preview' which triggers a save and afterwards modifies the same tag again it is not recognized as 'changed'.
	//cn3_document_changed = false;
}

/**
 * determine if P tags should be generated for the current node id
 * @return true if p-tags should be generated on enter, false otherwise
 */
function gtx_generatePs() {
	if (typeof(gtx_liveedit_p_nodeids) == 'undefined') {
		return false;
	}
	for (i = 0; i < gtx_liveedit_p_nodeids.length; i++) {
		if (gtx_liveedit_p_nodeids[i] == gtx_node_id || gtx_liveedit_p_nodeids[i] == '*') {
			return true;
		}
	}
	return false;
}

function isDivHandledKey( event )
{
    if (gtx_generatePs()) {
    	return false;
    }
    var key;
    key = cn3_getKeyCode( event );
    return ( key == 13 );
}
function DivHandleKey(el, event) {
    if (gtx_generatePs()) {
    	return false;
    }
    if (el != curr_element ) return true;

    var sk;
    sk = isDivHandledKey(event);
    if ( !sk ) return true;

    key = cn3_getKeyCode(event);
    switch ( key )
    {
	   case 13:
		range = cn3_getSelectionRange();
		cn3_insertBreak(range);
		break;
    }
    return true;
}

function removePs( txt ) {
    // only apply word cleaning if word specific formatting is found
    if (txt.search(/mso/i) > -1) {
    <?php
        if ($FEATURE["advanced_word_paste"]) {
                foreach ($ADVANCED_WORD_PASTE_REGEXPS as $k => $v) {
                        echo "txt = txt.replace($k, \"$v\");\n";
                }
        }
    ?>
    } else {
    	txt = txt.replace( /\<P[^>]*\>/ig, "" );
	txt = txt.replace( /\<\/P[^\>]*\>/ig, "<br /><br />" );
    	txt = txt.replace( /\<span[^>]*\>/ig, "" );
    	txt = txt.replace( /\<\/span[^\>]*>/ig, "" );
    }
    return txt;
}

// remove all html tags, but keep brs
function smartStripTags(txt, noDivNewline) {
    // remove all newlines
    txt = txt.replace(/\n/g, " ");
    // replace all blocklevelelement-endtags with brs
    txt = txt.replace(/<\/(ADDRESS|BLOCKQUOTE|CENTER|DIR|DL|FIELDSET|FORM|H1|H2|H3|H4|H5|H6|HR|ISINDEX|MENU|NOFRAMES|NOSCRIPT|OL|P|PRE|TABLE|UL|LI|DD|DT|FRAMESET|LI|TBODY|TD|TFOOT|TH|THEAD|TR)>/gi,"<br \/>");
    if ( !noDivNewline ) {
	txt = txt.replace(/<\/DIV>/gi, "<br \/>");
    }
    // turn breaks into newlines
    txt = txt.replace(/<br\s*\/?>/gi, "\n");
    // replace nbsp by whitespace
    txt = txt.replace(/&nbsp;/gi, " ");
    // now delete ALL tags from the source
    txt = txt.replace(/<[^>]+>/g, "");
    // restore breaks from newlines
    txt = txt.replace(/\n/g, "<br />");
    return txt;
}

<? /* only supported by IE currently; used for onbeforepaste event */ ?>
function DivOnBeforePaste(el) {
    if ( el != curr_element ) return true;
    execClipboardPaste(liveedit_stripwordpaste);
    return false;
}

/**
 * paste clipboard content
 * @param	smart use smartStripTags
 */
function execClipboardPaste(smart,range) {
    if (!range) {
	range = cn3_getSelectionRange();
    }
    var html = cn3_getClipboardContent();

    if (smart) {
        cn3_pasteHTML(range,smartStripTags(html, false));
    } else {
        cn3_pasteHTML(range,removePs(html));
    }
}

// remove all html tags, but keep brs
function smartStripTags(txt) {
		// remove all newlines
		txt = txt.replace(/\n/g, "");
		// replace all blocklevelelement-endtags with brs
		txt = txt.replace(/<\/(ADDRESS|BLOCKQUOTE|CENTER|DIR|DIV|DL|FIELDSET|FORM|H1|H2|H3|H4|H5|H6|HR|ISINDEX|MENU|NOFRAMES|NOSCRIPT|OL|P|PRE|TABLE|UL|LI|DD|DT|FRAMESET|LI|TBODY|TD|TFOOT|TH|THEAD|TR)>/gi,"<br \/>");
		// turn breaks into newlines
		txt = txt.replace(/<br\s*\/?>/gi, "\n");
		// replace nbsp by whitespace
		txt = txt.replace(/&nbsp;/gi, " ");
		// now delete ALL tags from the source
		txt = txt.replace(/<[^>]+>/g, "");
		// restore breaks from newlines
		txt = txt.replace(/\n/g, "<br />");
		return txt;
}

function displayMenu(el, visible, event) {
       if ( !menu_clicked )
       {
	       var has_context_menu = false;
	       var el_name = '';
	       for (i=0; i<cn3_tags.length; i++) {
		       if (el.id == 't_' + cn3_tags[i]) {
			       has_context_menu = true;
			       el_name = 't_' + cn3_tags[i];
		       }
		       for (j=0; j<cn3_parts[i].length; j++) {
			       if (el.id == 'p_' + cn3_tags[i] + '_' + cn3_parts[i][j]) {
				       has_context_menu = true;
				       el_name = 'p_' + cn3_tags[i] + '_' + cn3_parts[i][j];
			       }
		       }
	       }
	       if (has_context_menu) {
		       setTimeout('unclicked()', 100);
		       menu_clicked = true;
		       if (visible && curr_part == el_name) {
				cn3_document_cmenu(event);
		       }
	       }
       }
       return false;
}


function cn3_save_document  (urlOnSave) {
	 cn3_save_document( urlOnSave, false );
}
function cn3_save_document  (urlOnSave, inParent) {
	if ( urlOnSave ) {
		cn3_url_on_save = urlOnSave;
	}
	if (cn3_document_changed) {
		cn3_save_tags(node_stag+'&do=14009&p_id='+node_page_id);
	} else if ( urlOnSave ) {
		inParent = (parent == top.main.list);
		if(inParent) parent.location.href = urlOnSave;
		else document.location.href = urlOnSave;
	}
}

//this function displays the context menu; called by object-translate in edit mode!

function cn3_http_request( url, target )
{
	var getform = '<form id=cn3_http_request action=\"'+url+'\" method=post></form>';
	var rwin = window.open('', target,'dependent=yes,status=no,toolbar=no,scrollbars=no,width=30,height=20,resizable=no');

	rwin.document.open();
	rwin.document.write(getform);
	rwin.document.close();
	var rdiv = rwin.document.getElementById('cn3_http_request');
	rdiv.submit();
	return rwin;
}

function cn4_add_tag_http_request( url, target, field_name, field_value )
{
    var field_id = 'gtx_' + field_name;
	var getform = '<form id=cn3_http_request action=\"'+url+'\" method=post><input type=hidden id=\"' + field_id + '\" name=\"' + field_name + '\"></form>';
	var rwin = window.open('', target,'dependent=yes,status=no,toolbar=no,scrollbars=no,width=30,height=20,resizable=no');

	rwin.document.open();
	rwin.document.write(getform);
	rwin.document.close();
	var field = rwin.document.getElementById(field_id);
	field.value = field_value;
	var rdiv = rwin.document.getElementById('cn3_http_request');
	rdiv.submit();
	return rwin;
}

var cn3_get_win;

function cn3_add_tag( range, constructid, fstarget )
{
	progress(top.menu);
	//$construct_id,$o_type,$mother_id,$mother_type for obj_translate
	//$editable: translate editable
	var url = node_stag+'&do=16669&callback='+fstarget+'.load_finished';
	url += '&cmd=create_translated_tag&construct_id='+constructid;
	url += '&o_type=contenttag&mother_id='+node_page_id+'&mother_type=page&editable='+node_editable;
	// url += '&magic_value='+encodeURIComponent(cn3_getRangeText(range));
	if (backparam) {
		url += '&backparam='+backparam;
	}
	// cn3_get_win = cn3_http_request( url, 'temp' );
	cn3_get_win = cn4_add_tag_http_request( url, 'temp', 'magic_value',  cn3_getRangeText(range) );
}

// refresh will be set to true when a tag is inserted via soap.php that uses javascript (edit view needs to be refreshed)
function load_finished( refresh )
{
	var str = cn3_getInnerText(cn3_get_win.document.body);
	var div = str.match(/<(?:div|span) .*<\/(?:div|span)>/);
	cn3_range_pasteHTML( div );

<?	/*
	var soapstr = str.match(/%%(.*)%%/);
	var soap = soapstr[1].split('%%');
	//soap0: name of the tag
	//soap1-.length-1: editable partorders
	var nextid = cn3_tags.length;
	cn3_tags[nextid] = soap[0];
	cn3_parts[nextid] = new Array();

	for ( var i=1; i<soap.length; i++ )
	{
		cn3_parts[nextid][i-1] = soap[i];
	}
        */
?>
	// copy cn3_tags, cn3_parts, cn3_childable
	cn3_tags = cn3_tags.concat( cn3_get_win.cn3_tags );
	cn3_parts = cn3_parts.concat( cn3_get_win.cn3_parts );
	cn3_childable = cn3_childable.concat( cn3_get_win.cn3_childable );
	stop_progress(top.menu);

    // eventually refresh the edit view by calling method gtx_reload_edit()
    if (refresh && gtx_reload_edit) {
      gtx_reload_edit();
    }
}

function insertSpecialChar(c) {
  cn3_range_pasteHTML(c);
}

/**
 * Stops the event bubbling for not inline editable elements that are embedded within live editable elements.
 */
function stopBubble(e) {
	var event = e || window.event;
	if (event.stopPropagation) {
		event.stopPropagation();
	} else {
		event.cancelBubble = true;
	} 
}

/**
 * open the paste area in a new window
 * add this function to the context menu if you want to use the paster
 */
function gtx_openPaster() {
	window.open('<?=$STAG;?>&do=14022&mode=paste', 'gtx_paster', 
		'location=no,menubar=no,status=no,toolbar=no');
}

/**
 * Creates the html representation of a table dom element
 * @param element The dom element
 * @return the html code of the table
 */
function gtx_createTableHtml(originalTable) {
	var element = originalTable.cloneNode(true);
	var divTags = element.getElementsByTagName('div');
	var spanTags = element.getElementsByTagName('span');
	var allTags = new Array();
	allTags.concat(divTags);
	allTags.concat(spanTags);
	
	for (i=0;i<allTags.length;i++) {
		tag = allTags[i];
		if (tag.id.substr(0,2) == 't_') {
			gtx_extractedTags.push({
				"id" : tag.id,
				"outerHTML" : tag.outerHTML
			});
			tag.outerHTML = '<span class="mceNonEditable">&lt;node ' + tag.id + '&gt;</span>';
		}
	}
	
	return element.outerHTML;
}

/**
 * Replaces a original table with a new one
 * @param original The original Table
 * @param element The new table
 */
function gtx_replaceTable(html) {
	if (html == null) {
		html = gtx_table.outerHTML;
	}
	
	for (i=0; i<gtx_extractedTags.length; i++) {
		html = html.replace('<span class="mceNonEditable">&lt;node ' + gtx_extractedTags[i].id + "&gt;</span>", gtx_extractedTags[i].outerHTML);
	}
	if (gtx_table) {
		gtx_table.outerHTML = html;
	}
}

/**
 * Opens the table editor in a new window.
 * @param event The browser event fired when 
 */
function gtx_openTableEditor() {
	var event = window.event;
	var create = true;
	
	gtx_createTable = true;
	
	var element = cn3_text_range.parentElement();
	
	do {
		// The element is contentEditable -> we don't have a table
		if (element.getAttribute("contentEditable").toLowerCase() == 'true') {
			break;
		}

		// We have a table -> edit it
		if (element.nodeName == 'TABLE') {
			gtx_table = element;
			gtx_tableHtml = gtx_createTableHtml(gtx_table);
			gtx_createTable = false;
		}
	} while (element = element.parentNode);
	
	if (gtx_createTable) {
		gtx_tableHtml = 
			"<table>" +
			"<tr>" +
				"<th>Spalte 1</th>" +
				"<th>Spalte 2</th>" +
			"</tr>" +
			"<tr>" +
			"<td></td><td></td>" +
			"</tr>" +
			"</table>";
	}
	
	var popup = window.open('<?=$STAG;?>&do=14022&mode=table', 'gtx_paster', 
	'location=no,menubar=no,status=yes,toolbar=no');
}

/**
 * @return gets the html that should
 */
function gtx_getTableHTML() {
	return gtx_tableHtml;
}

/**
 * updates the current table with the html produced by tinymce
 * @param dom element of the table
 */
function gtx_updateTable(html) {
	if (gtx_createTable) {
		cn3_range_pasteHTML(html)
	} else {
		gtx_replaceTable(html);
	}

	gtx_tidyCurrentRange();
}

function gtx_transformPasteFromWord(html) {
	return html
	// remove all links from the text
		.replace(/<a[^>]+>(.*?)<\/a>/gi,"$1")
	// remove underlined text pasted from word
	    .replace(/<span style=\"text-decoration: ?underline;\">(.*?)<\/span>/gi,"<u>$1</u>");
}

/**
 * paste back contents from paster window
 */
function gtx_pasteBack(html) {
	cn3_range_pasteHTML(gtx_transformPasteFromWord(html));
	gtx_tidyCurrentRange();
}

/**
 * Tidy the contenteditable containing the current selection
 */
function gtx_tidyCurrentRange() {
	var element = cn3_text_range.parentElement();
	do {
		// The element is contentEditable -> we don't have a table
		if (element.getAttribute("contentEditable").toLowerCase() == 'true') {
			gtx_tidyElementContent(element);
			// this fixes a bug, where - when the context menu doesn't
			// close after executing a formatting action (which is a bug
			// itself) - another click on a formatting action selects
			// and transforms the entire editable.
			if (document.selection) {
				document.selection.empty();
				cn3_text_range = document.selection.createRange();
			}
			break;
		}
	} while (element = element.parentNode);
}

/**
 * Determine whether the liveeditable content should be tidied for the current node id
 * @return true if the content should be tidied, false if not
 */
function gtx_isLiveEditTidy() {
	if (typeof(gtx_liveedit_tidy) == 'undefined') {
		return false;
	}
	for (i = 0; i < gtx_liveedit_tidy.length; i++) {
		if (gtx_liveedit_tidy[i] == gtx_node_id || gtx_liveedit_tidy[i] == '*') {
			return true;
		}
	}
	return false;
}

/**
 * tidy the content of the given element:
 * send an AJAX request to the tidy servlet and when the servlet returns the tidy html code,
 * replace the innerhtml of the given element.
 * @param element element to make tidy
 */
function gtx_tidyElementContent(element) {
	// when the content of the current node should not be tidied, we do nothing
	if (!gtx_isLiveEditTidy()) {
		return;
	}

    // no element given, so nothing to do
	if (!element) {
		return;
	}
	
	// prepare html contents of the element to be tidied
	var cloaker = new GTXNodeTagCloaker();
	var toTidy = cloaker.cloak(element);

	// create the request object
	var xmlHttpRequest = gtx_getXMLHttpRequest();
	if (!xmlHttpRequest) {
	    // could not get the request object, so this will fail
		return;
	}

	// we need to POST the data to the tidy servlet
	xmlHttpRequest.open("POST", "/CNPortletapp/tidy?node_id=" + gtx_node_id, true);

	// set additional request headers (do not leave the connection open and set the charset to UTF-8)
	xmlHttpRequest.setRequestHeader("Connection", "close");
	xmlHttpRequest.setRequestHeader("Content-Type", "text/html; charset=UTF-8");

	
	// set an event handler for changes of the state
 	xmlHttpRequest.onreadystatechange=function() {
 		// only replace the content when the response was OK and contained content
  		if (xmlHttpRequest.readyState == 4 && xmlHttpRequest.status == 200 && xmlHttpRequest.responseText) {
			// set the result as innerHTML of the given element
   			element.innerHTML = cloaker.restore(xmlHttpRequest.responseText);
  		}
	}

	// now we will send the request, POSTing the html content to tidy
	xmlHttpRequest.send(toTidy);
}

var GTXNodeTagCloaker = function(){};
GTXNodeTagCloaker.prototype.divElements = null;
GTXNodeTagCloaker.prototype.spanElements = null;
/**
 * cloak all node tags within that element
 * @param element html element which contents have to be cloaked
 * @return string cloaked html content 
 */
GTXNodeTagCloaker.prototype.cloak = function(element) {
	var element = element.cloneNode(true);
	
	// reset the arrays before cloaking to prevent mixing old items when the cloaker was used before
	this.divElements = new Array();
	this.spanElements = new Array();
	
	// cloak div elements first
	var divs = element.getElementsByTagName('div');
	for (var i=0;i<divs.length;i++) {
		var tag = divs[i];
		if (tag.id.substr(0,2) == 't_') {
			this.divElements.push({
				"id" : tag.id,
				"outerHTML" : tag.outerHTML
			});
			tag.outerHTML = '#GTXNODETAG#' + tag.id + '#ENDGTXNODETAG#';
		}
	}
	
	// now cloak span elements
	var spans = element.getElementsByTagName('span');
	for (i=0;i<spans.length;i++) {
		var tag = spans[i];
		if (tag.id.substr(0,2) == 't_') {
			this.spanElements.push({
				"id" : tag.id,
				"outerHTML" : tag.outerHTML
			});
			tag.outerHTML = '#GTXNODETAG#' + tag.id + '#ENDGTXNODETAG#';
		}
	}
	
	return element.innerHTML;
};
/**
 * restore cloaked contents
 * @param content string
 * @return string restored string with original node tags
 */
GTXNodeTagCloaker.prototype.restore = function(content) {
	// restore div elements
	for (var i=0;i<this.divElements.length;i++) {
		content = content.replace('#GTXNODETAG#' + this.divElements[i].id + '#ENDGTXNODETAG#', this.divElements[i].outerHTML);
	}
	// restore spans
	for (i=0;i<this.spanElements.length;i++) {
		content = content.replace('#GTXNODETAG#' + this.spanElements[i].id + '#ENDGTXNODETAG#', this.spanElements[i].outerHTML);
	}
	return content;
};

/**
 * remove node tags from an element to be tidied
 * @param element The dom element
 * @return array with element code and array of replaced contents
 */
function gtx_escapeTidyElement(element) {
	
	gtx_extractedTidyMasked = new Array();
	
	element = originalTable.cloneNode(true);
	
	// replace divs first
	allTags = element.getElementsByTagName('div');
	for (i=0;i<allTags.length;i++) {
		tag = allTags[i];
		if (tag.id.substr(0,2) == 't_') {
			gtx_extractedTidyMasked.push({
				"id" : tag.id,
				"outerHTML" : tag.outerHTML
			});
			tag.outerHTML = '#GTXNODETAG#' + tag.id + '#ENDGTXNODETAG#';
		}
	}
	
	return element.outerHTML;
}

function gtx_cleanLoopElements(elems) {
	
}

/**
 * Get the html request object
 * @return html request object for AJAX calls or null if not available
 */
function gtx_getXMLHttpRequest() {
    if (window.XMLHttpRequest) {
        return new window.XMLHttpRequest;
    } else {
        try {
        	// this is the ms specific way to do this
            return new ActiveXObject("MSXML2.XMLHTTP.3.0");
        } catch(ex) {
            return null;
        }
    }
}

<?
if ($FEATURE['liveedit_spans'] || $FEATURE['liveedit_tag_perconstruct']) {		
	// if we're using spans cleanup is necessary, as of ticket #36329 
?>
//cleanup broken ie drag, which may leave original object in place
if (typeof window.attachEvent != 'undefined') {
	window.attachEvent('onload', function () {
		document.body.attachEvent('ondragend', function() {
			var gtxTag = false;
			
			// check if a gentics tag has been dragged 
			for (i=0; i<cn3_tags.length; i++) {
				if ('t_' + cn3_tags[i] == event.srcElement.id) {
					gtxTag = true;
					break;
				}
			}
			
			if (!gtxTag) {
				return;
			}
			
			// cleanup old tag
			event.srcElement.outerHTML = "";
		});
	});
}
<?
}		
?>