<?

class CollectionComponent extends FormComponent {

var $d_components;
var $d_componentIds = array();
var $d_firstErrorKey;


function CollectionComponent($label=NULL) {
parent::FormComponent();
$this->setLabel($label);
$this->d_components = new HashCollection();
}

function getFocusableElementName($resolvable=FALSE)
{
if ( $resolvable ) $sep = ".";
$i = $this->iterator();
while ( $i->hasNext() )
{
unset( $ele );
$ele =& $i->next();
$name = $ele->getFocusableElementName();
if ( $name ) return $i->getKey() . $sep . $name;
}
return NULL;
}

function setShortcut( $key, $script, $override=TRUE )
{
$i = $this->iterator();
while ( $i->hasNext() )
{
unset( $ele );
$ele =& $i->next();
$ele->setShortcut( $key, $script, $override );
}
}

function getFirstErrorElementKey()
{
return $this->d_firstErrorKey;
}

function setFieldError( $field, $exception, $severity = FM_SEVERITY_SUBMIT ) {
$list = explode( ".", $field );
if ( count( $list ) == 1 )
parent::setFieldError( $field, $exception, $severity );
else
{
$field = end( $list );
$comp = implode( ".", array_slice( $list, 0, -1 ) );
$c =& $this->resolveComponent( $comp );
$c->setFieldError( $field, $exception, $severity );
} 
}

function addError( $exception, $severity = FM_SEVERITY_SUBMIT ) 
{
$field = $this->getFocusableElementName(true);
if ( $field )
{
$this->setFieldError( $field, $exception, $severity );
}
else
{
$fields = $this->getFields(true);
if ( is_array( $fields ) && count( $fields ) > 0 )
{
reset( $fields );	
$this->setFieldError( key($fields), $exception, $severity );
}
}
}

function getError($severity = FM_SEVERITY_DEFAULT ) {
return $this->getComponentError( $this->getComponents(), $severity );
}

function getComponentError( $components, $severity = FM_SEVERITY_DEFAULT )
{
if ( !is_array( $components ) ) $components = array( $components );
$i = $this->d_components->iterator();
$error = parent::getError($severity,true);
while ($i->hasNext()) {
unset( $comp );
$comp =& $i->next();
$key = $i->getKey();
if ( in_array($key, $components) )
{
$err = $comp->getError($severity);
if ($err !== NULL) {
if ( !is_array($err) )
$err = array( $err );
}
if ( count($err) )
{
if ( !$this->d_firstErrorKey )
$this->d_firstErrorKey = $key;
foreach ( $err as $k=>$e )
$error[$key.$k] = $e;
}
}
}
return $error;
}

function &getResultObject() {
return new NodeException("CollectionComponent: getResultObject not implemented.");
}

function reset() {
$i = $this->d_components->iterator();
while ($i->hasNext()) {
unset( $comp );
$comp =& $i->next();
$comp->reset();
}
}

function getSerializeKey() {
$rs["parent"] = parent::getSerializeKey();
$j=0;
$it = $this->d_components->iterator();
while ( $it->hasNext() )
{
unset( $comp );
$comp = &$it->next();
$key = $it->getKey();
if ( !isset( $this->d_componentIds[$key] ) )
{
$this->d_componentIds[$key] = mysession_createUnique();
}
$id = $this->d_componentIds[$key];
mysession_updateUnique( $id, $comp );
}
$rs["components"] = $this->d_componentIds;
return $rs;
}

function initFromSerializeKey( $key ) {
parent::initFromSerializeKey( $key["parent"] );
$this->d_components = new HashCollection();
$this->d_componentIds = $key["components"];
foreach($key["components"] as $k=>$id) {
$comp = &mysession_loadUnique($id, TRUE);
if (!is_object($comp)) {
BaseObject::addDebugMessage(i18n("Could not load FormComponent from session ({0}).",0,$id));
} else {
$this->d_components->add($k, $comp);
}
//                                                                               
 unset($comp);
}
}

function cleanupSerializeKey( $key ) {
parent::cleanupSerializeKey( $key["parent"] );
if( $key["components"] === null) {
return;
}
foreach($key["components"] as $k=>$id) {
mysession_cleanupUnique($id);
}   
}

function onLoadFinished(&$form) {
$i = $this->d_components->iterator();
while ($i->hasNext()) {
unset( $comp );
$comp =& $i->next();
$fields = $comp->getFields();
$prefix = $i->getKey();
foreach ($fields as $field=>$desc) {
if ( array_key_exists($prefix.$field, $this->d_values ) )
{
$comp->setFieldValue($field, $this->d_values[$prefix.$field]);
unset( $this->d_values[$prefix.$field] );
}
}
$comp->onLoadFinished(&$form);
}
}

function isFinished() {
$finished = true;
$i = $this->d_components->iterator();
while ($i->hasNext()) {
unset( $comp );
$comp =& $i->next();
$cFinished = $comp->isFinished();
$finished = $cFinished && $finished;
}
return $finished;
}

function getFields($resolvable=FALSE) {
$fields = parent::getFields();
if ( $resolvable ) $sep = ".";
$i = $this->d_components->iterator();
while ($i->hasNext()) {
unset ( $comp );
$comp =& $i->next();
$prefix = $i->getKey();
$rs = $comp->getFields();
foreach ($rs as $field=>$desc) {
$fields[$prefix.$sep.$field] = $desc;
}
}
return $fields;
}

/**
  *                                                                                   
  *                                                                    
  *                                                                                         
  **/
function resolveFieldValue( $propertyField )
{
$result =& resolvePropertyObject($propertyField, $this);
if ( is_a($result["obj"], "nodeexception") )
return $result["obj"];
return $result["obj"]->getFieldValue( $result["prop"] );
}

function iterator() {
return $this->d_components->iterator();
}

function setComponent($key, &$component, $afterComponent = false) {
if (!is_a($component, "formcomponent")) return false;
if ($this->d_components->keyExists($key)) {
$this->d_components->remove($key);
}
if ($afterComponent !== false) {
$this->d_components->insert($key, $component, $afterComponent);
} else {
$this->d_components->add($key, $component);
}
return true;
}

function &unsetComponent($key) {
return $this->d_components->remove($key);
}

function unsetComponents() {
$this->clearComponents();
}

function &getComponent( $key ) {
return $this->d_components->getByKey($key);
}

function &resolveComponent( $key ) {
return resolveProperty( $key, $this );
}

function componentExists( $key )
{
return $this->d_components->keyExists( $key );
}

function getComponents() {
return $this->d_components->getKeys();
}

function clearComponents() {
$this->d_components->clear();
}

function _getComponentHTML( $keys, &$form, $prefix, $doCheck, $checkSeverity, $partKey ) {
if ( !is_array($keys) ) $keys = array($keys);

$retArr = array();
foreach ( $keys as $key )
{ 	
unset ( $comp );
$comp =& $this->getComponent( $key );
if ( !is_a( $comp, "formcomponent" ) ) { continue; }
if ( $comp->isHidden() ) { continue; }

if ( !isset($this->d_componentIds[$key]) )
$this->d_componentIds[$key] = mysession_createUnique();
$comp->setUniqueKey( $this->d_componentIds[$key] );
if ( $partKey ) $childPartKey = $partKey.".".$key;
else $childPartKey = $key;
$rs = $comp->getHTML( $form, $prefix.$key, $doCheck, $checkSeverity, $childPartKey );

if (!is_array($rs)) {
$lbl = $comp->getLabel();
if ($lbl !== NULL) {
$rs = array($lbl, $rs);
}
$retArr[] = $rs;
} else {
foreach ($rs as $key=>$val) $retArr[] = $val;
}
}
return $retArr;
}

function _getComponentHTMLTable( $keys, &$form, $prefix, $doCheck, $checkSeverity, $partKey, $labelsOnTop=FALSE, $tableFormat = "" )
{
if ( !is_array($keys) ) $keys = array($keys);

$html .= "<table $tableFormat>\n<tbody>\n";

$parts = $keys;
foreach ($parts as $pKey) {
$code = $this->_getComponentHTML( $pKey, $form, $prefix, $doCheck, $checkSeverity, $partKey );
foreach($code as $key=>$out) {
$html .= $this->translateRow($out,"","",$labelsOnTop);
}
}

$html .= "</tbody>\n</table>";
return $html;
}

function getPropertyNames() {
return $this->d_components->getPropertyNames();
}

function &getProperty($key) {
return $this->getComponent($key);
}

}

class ListComponent extends CollectionComponent {

function ListComponent() {
parent::CollectionComponent();
}

function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key ) {
$html = parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key );
$htmlAdd = $this->_getComponentHTML( $this->getComponents(), $form, $prefix, $doCheck, $checkSeverity, $key );
return $this->mergeResult($html,$htmlAdd);
}

}

class ColumnComponent extends CollectionComponent {

function ColumnComponent($label = "", $splitter = "&nbsp") {
parent::CollectionComponent($label);
$this->setSplitter($splitter);
}

function setSplitter($splitter) {
$this->d_values["splitter"] = $splitter;
}

function getSplitter() {
return $this->d_values["splitter"];
}

function getHTML(&$form, $prefix, $doCheck, $checkSeverity, $key ) {
$htmlAdd = $this->_getComponentHTML( $this->getComponents(), $form, $prefix, $doCheck, $checkSeverity, $key );
$html = "<nobr>";
foreach( $htmlAdd as $key=>$ele) {
$html .= is_array($ele)?$ele[1]:$ele;
$html .= $this->getSplitter();
}
$html .= "</nobr>";
return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
}
}

class SelectableListComponent extends ListComponent { //                      
 
function SelectableListComponent() {
parent::ListComponent();
}

function startSelection()
{
$this->d_values["selopen"] = TRUE;
}

function selectionFinished()
{
$this->d_values["selopen"] = FALSE;
}

function isSelectionOpen()
{
return $this->d_values["selopen"];
}

function isSelectionComplete()
{
return $this->isFinished() && !$this->isSelectionOpen();
}

}

?>
