<?php




/**
*
*                                              
*
*       
*
* //                                    
*                                                              
*
* //                         
*                                                                  
*
* //               
*                    
*
*                                              
*                                                                            
*                 
*/
class soapclient extends nusoap_base  {

var $username = '';
var $password = '';
var $authtype = '';
var $certRequest = array();
var $requestHeaders = false;	//                               
 var $responseHeaders = '';		//                                                                    
 var $document = '';				//                                                                    
 var $endpoint;
var $forceEndpoint = '';		//                        
 var $proxyhost = '';
var $proxyport = '';
var $proxyusername = '';
var $proxypassword = '';
var $xml_encoding = '';			//                                                       
 var $http_encoding = false;
var $timeout = 0;				//                        
 var $response_timeout = 30;		//                      
 var $endpointType = '';			//                                               
 var $persistentConnection = false;
var $defaultRpcParams = false;	//                       
 var $request = '';				//             
 var $response = '';				//              
 var $responseData = '';			//                         
 var $cookies = array();			//                                     
 var $decode_utf8 = true;		//                                                     /              
 var $operations = array();		//                                                     
 
/*
  *                        
  */
/**
  *                
  *                 
  */
var $fault;
/**
  *                    
  *                 
  */
var $faultcode;
/**
  *                      
  *                 
  */
var $faultstring;
/**
  *                      
  *                 
  */
var $faultdetail;

/**
 *            
 *
 *                                                                                      
 *                                                         
 *                                                        
 *                            
 *                            
 *                             
 *                             
 *                                                   
 *                                                          
 *                 
 */
function soapclient($endpoint,$wsdl = false,$proxyhost = false,$proxyport = false,$proxyusername = false, $proxypassword = false, $timeout = 0, $response_timeout = 30){
parent::nusoap_base();
$this->endpoint = $endpoint;
$this->proxyhost = $proxyhost;
$this->proxyport = $proxyport;
$this->proxyusername = $proxyusername;
$this->proxypassword = $proxypassword;
$this->timeout = $timeout;
$this->response_timeout = $response_timeout;

//            
 if($wsdl){
if (is_object($endpoint) && (get_class($endpoint) == 'wsdl')) {
$this->wsdl = $endpoint;
$this->endpoint = $this->wsdl->wsdl;
$this->wsdlFile = $this->endpoint;
$this->debug('existing wsdl instance created from ' . $this->endpoint);
} else {
$this->wsdlFile = $this->endpoint;

//                                            
 $this->debug('instantiating wsdl class with doc: '.$endpoint);
$this->wsdl =& new wsdl($this->wsdlFile,$this->proxyhost,$this->proxyport,$this->proxyusername,$this->proxypassword,$this->timeout,$this->response_timeout);
}
$this->appendDebug($this->wsdl->getDebug());
$this->wsdl->clearDebug();
//             
 if($errstr = $this->wsdl->getError()){
$this->debug('got wsdl error: '.$errstr);
$this->setError('wsdl error: '.$errstr);
} elseif($this->operations = $this->wsdl->getOperations()){
$this->debug( 'got '.count($this->operations).' operations from wsdl '.$this->wsdlFile);
$this->endpointType = 'wsdl';
} else {
$this->debug( 'getOperations returned false');
$this->setError('no operations defined in the WSDL document!');
}
} else {
$this->debug("instantiate SOAP with endpoint at $endpoint");
$this->endpointType = 'soap';
}
}

/**
 *                                      
 *
 *                                                 
 *                                                                           
 *                                                                 
 *                                                             
 *                                                                 
 *                                                                  
 *                                                                       
 *                                                                    
 *                                    
 *                                                                          
 *                                                                          
 *                                                                         
 *                         *    *                     
 *                                                                       
 *                                                                        
 *                                                                                                                    
 *                                                    
 *                                                                                                              
 *                                                                                                      
 *                                      
 *                 
 */
function call($operation,$params=array(),$namespace='http://tempuri.org',$soapAction='',$headers=false,$rpcParams=null,$style='rpc',$use='encoded'){
$this->operation = $operation;
$this->fault = false;
$this->setError('');
$this->request = '';
$this->response = '';
$this->responseData = '';
$this->faultstring = '';
$this->faultcode = '';
$this->opData = array();

$this->debug("call: operation=$operation, namespace=$namespace, soapAction=$soapAction, rpcParams=$rpcParams, style=$style, use=$use, endpointType=$this->endpointType");
$this->appendDebug('params=' . $this->varDump($params));
$this->appendDebug('headers=' . $this->varDump($headers));
if ($headers) {
$this->requestHeaders = $headers;
}
//                     
 if($this->endpointType == 'wsdl' && $opData = $this->getOperationData($operation)){
//                       
 $this->opData = $opData;
$this->debug("found operation");
$this->appendDebug('opData=' . $this->varDump($opData));
if (isset($opData['soapAction'])) {
$soapAction = $opData['soapAction'];
}
if (! $this->forceEndpoint) {
$this->endpoint = $opData['endpoint'];
} else {
$this->endpoint = $this->forceEndpoint;
}
$namespace = isset($opData['input']['namespace']) ? $opData['input']['namespace'] :	$namespace;
$style = $opData['style'];
$use = $opData['input']['use'];
//                   
 if($namespace != '' && !isset($this->wsdl->namespaces[$namespace])){
$nsPrefix = 'ns' . rand(1000, 9999);
$this->wsdl->namespaces[$nsPrefix] = $namespace;
}
$nsPrefix = $this->wsdl->getPrefixFromNamespace($namespace);
//                  
 if (is_string($params)) {
$this->debug("serializing param string for WSDL operation $operation");
$payload = $params;
} elseif (is_array($params)) {
$this->debug("serializing param array for WSDL operation $operation");
$payload = $this->wsdl->serializeRPCParameters($operation,'input',$params);
} else {
$this->debug('params must be array or string');
$this->setError('params must be array or string');
return false;
}
$usedNamespaces = $this->wsdl->usedNamespaces;
if (isset($opData['input']['encodingStyle'])) {
$encodingStyle = $opData['input']['encodingStyle'];
} else {
$encodingStyle = '';
}
$this->appendDebug($this->wsdl->getDebug());
$this->wsdl->clearDebug();
if ($errstr = $this->wsdl->getError()) {
$this->debug('got wsdl error: '.$errstr);
$this->setError('wsdl error: '.$errstr);
return false;
}
} elseif($this->endpointType == 'wsdl') {
//                      
 $this->appendDebug($this->wsdl->getDebug());
$this->wsdl->clearDebug();
$this->setError( 'operation '.$operation.' not present.');
$this->debug("operation '$operation' not present.");
return false;
} else {
//        
 //                                      
 $nsPrefix = 'ns' . rand(1000, 9999);
//           
 $payload = '';
if (is_string($params)) {
$this->debug("serializing param string for operation $operation");
$payload = $params;
} elseif (is_array($params)) {
$this->debug("serializing param array for operation $operation");
foreach($params as $k => $v){
$payload .= $this->serialize_val($v,$k,false,false,false,false,$use);
}
} else {
$this->debug('params must be array or string');
$this->setError('params must be array or string');
return false;
}
$usedNamespaces = array();
if ($use == 'encoded') {
$encodingStyle = 'http://schemas.xmlsoap.org/soap/encoding/';
} else {
$encodingStyle = '';
}
}
//                                   
 if ($style == 'rpc') {
if ($use == 'literal') {
$this->debug("wrapping RPC request with literal method element");
if ($namespace) {
$payload = "<$operation xmlns=\"$namespace\">" . $payload . "</$operation>";
} else {
$payload = "<$operation>" . $payload . "</$operation>";
}
} else {
$this->debug("wrapping RPC request with encoded method element");
if ($namespace) {
$payload = "<$nsPrefix:$operation xmlns:$nsPrefix=\"$namespace\">" .
$payload .
"</$nsPrefix:$operation>";
} else {
$payload = "<$operation>" .
$payload .
"</$operation>";
}
}
}
//                   
 $soapmsg = $this->serializeEnvelope($payload,$this->requestHeaders,$usedNamespaces,$style,$use,$encodingStyle);
$this->debug("endpoint=$this->endpoint, soapAction=$soapAction, namespace=$namespace, style=$style, use=$use, encodingStyle=$encodingStyle");
$this->debug('SOAP message length=' . strlen($soapmsg) . ' contents (max 1000 bytes)=' . substr($soapmsg, 0, 1000));
//     
 $return = $this->send($this->getHTTPBody($soapmsg),$soapAction,$this->timeout,$this->response_timeout);
if($errstr = $this->getError()){
$this->debug('Error: '.$errstr);
return false;
} else {
$this->return = $return;
$this->debug('sent message successfully and got a(n) '.gettype($return));
$this->appendDebug('return=' . $this->varDump($return));

//       
 if(is_array($return) && isset($return['faultcode'])){
$this->debug('got fault');
$this->setError($return['faultcode'].': '.$return['faultstring']);
$this->fault = true;
foreach($return as $k => $v){
$this->$k = $v;
$this->debug("$k = $v<br>");
}
return $return;
} elseif ($style == 'document') {
//                                                                          
 //                                                                   
 return $return;
} else {
//                       
 if(is_array($return)){
//                                                      
 //             
 if(sizeof($return) > 1){
return $return;
}
//                                                   
 $return = array_shift($return);
$this->debug('return shifted value: ');
$this->appendDebug($this->varDump($return));
return $return;
//                                
 } else {
return "";
}
}
}
}

/**
 *                                              
 *
 *                                           
 *                                                        
 *                 
 */
function getOperationData($operation){
if(isset($this->operations[$operation])){
return $this->operations[$operation];
}
$this->debug("No data for operation: $operation");
}

/**
    *                      
    *
    *                                                  
    *                                                 
    *                 
    *
 *                                              
 *                                              
 *                                                             
 *                                                                 
 *                                
 *                  
 */
function send($msg, $soapaction = '', $timeout=0, $response_timeout=30) {
$this->checkCookies();
//                 
 switch(true){
//        
 case ereg('^http',$this->endpoint):
$this->debug('transporting via HTTP');
if($this->persistentConnection == true && is_object($this->persistentConnection)){
$http =& $this->persistentConnection;
} else {
$http = new soap_transport_http($this->endpoint);
if ($this->persistentConnection) {
$http->usePersistentConnection();
}
}
$http->setContentType($this->getHTTPContentType(), $this->getHTTPContentTypeCharset());
$http->setSOAPAction($soapaction);
if($this->proxyhost && $this->proxyport){
$http->setProxy($this->proxyhost,$this->proxyport,$this->proxyusername,$this->proxypassword);
}
if($this->authtype != '') {
$http->setCredentials($this->username, $this->password, $this->authtype, array(), $this->certRequest);
}
if($this->http_encoding != ''){
$http->setEncoding($this->http_encoding);
}
$this->debug('sending message, length='.strlen($msg));
if(ereg('^http:',$this->endpoint)){
//                                    
 $this->responseData = $http->send($msg,$timeout,$response_timeout,$this->cookies);
} elseif(ereg('^https',$this->endpoint)){
//                                           
 //                                
 //                                                         
 //                                         
 //                                          
 //      
 $this->responseData = $http->sendHTTPS($msg,$timeout,$response_timeout,$this->cookies);
} else {
$this->setError('no http/s in endpoint url');
}
$this->request = $http->outgoing_payload;
$this->response = $http->incoming_payload;
$this->appendDebug($http->getDebug());
$this->UpdateCookies($http->incoming_cookies);

//                                                      
 if ($this->persistentConnection) {
$http->clearDebug();
if (!is_object($this->persistentConnection)) {
$this->persistentConnection = $http;
}
}

if($err = $http->getError()){
$this->setError('HTTP Error: '.$err);
return false;
} elseif($this->getError()){
return false;
} else {
$this->debug('got response, length='. strlen($this->responseData).' type='.$http->incoming_headers['content-type']);
return $this->parseResponse($http->incoming_headers, $this->responseData);
}
break;
default:
$this->setError('no transport found, or selected transport is not yet supported!');
return false;
break;
}
}

/**
 *                                            
 *
 *                                       
 *                                                           
 *                                                            
 *                  
 */
function parseResponse($headers, $data) {
$this->debug('Entering parseResponse() for data of length ' . strlen($data) . ' and type ' . $headers['content-type']);
if (!strstr($headers['content-type'], 'text/xml')) {
$this->setError('Response not of type text/xml');
return false;
}
if (strpos($headers['content-type'], '=')) {
$enc = str_replace('"', '', substr(strstr($headers["content-type"], '='), 1));
$this->debug('Got response encoding: ' . $enc);
if(eregi('^(ISO-8859-1|US-ASCII|UTF-8)$',$enc)){
$this->xml_encoding = strtoupper($enc);
} else {
$this->xml_encoding = 'US-ASCII';
}
} else {
//                                                           
 $this->xml_encoding = 'ISO-8859-1';
}
$this->debug('Use encoding: ' . $this->xml_encoding . ' when creating soap_parser');
$parser = new soap_parser($data,$this->xml_encoding,$this->operation,$this->decode_utf8);
//                                   
 $this->appendDebug($parser->getDebug());
//                
 if($errstr = $parser->getError()){
$this->setError( $errstr);
//                          
 unset($parser);
return false;
} else {
//                 
 $this->responseHeaders = $parser->getHeaders();
//                    
 $return = $parser->get_response();
//                                
 $this->document = $parser->document;
//                          
 unset($parser);
//                      
 return $return;
}
}

/**
 *                                                
 *
 *                                                                                              
 *                 
 */
function setEndpoint($endpoint) {
$this->forceEndpoint = $endpoint;
}

/**
 *                     
 *
 *                                                                                                           
 *                 
 */
function setHeaders($headers){
$this->requestHeaders = $headers;
}

/**
 *                                                                
 *
 *               
 *                 
 */
function getHeaders(){
return $this->responseHeaders;
}

/**
 *                    
 *
 *                            
 *                            
 *                             
 *                             
 *                 
 */
function setHTTPProxy($proxyhost, $proxyport, $proxyusername = '', $proxypassword = '') {
$this->proxyhost = $proxyhost;
$this->proxyport = $proxyport;
$this->proxyusername = $proxyusername;
$this->proxypassword = $proxypassword;
}

/**
 *                                             
 *
 *                           
 *                           
 *                                                   
 *                                                                                                                                                                                          
 *                 
 */
function setCredentials($username, $password, $authtype = 'basic', $certRequest = array()) {
$this->username = $username;
$this->password = $password;
$this->authtype = $authtype;
$this->certRequest = $certRequest;
}

/**
 *                  
 *
 *                      
 *                 
 */
function setHTTPEncoding($enc='gzip, deflate'){
$this->http_encoding = $enc;
}

/**
 *                                            
 *
 *                 
 */
function useHTTPPersistentConnection(){
$this->persistentConnection = true;
}

/**
 *                                        
 *                                                                           
 *                                     
 *
 *                        
 *
 *                
 *               
 *            
 */
function getDefaultRpcParams() {
return $this->defaultRpcParams;
}

/**
 *                                        
 *                                                                          
 *                                     
 *
 *                        
 *
 *                             
 *               
 *            
 */
function setDefaultRpcParams($rpcParams) {
$this->defaultRpcParams = $rpcParams;
}

/**
 *                                                  
 *                                                 
 *
 *                                   
 *                 
 */
function getProxy(){
$r = rand();
$evalStr = $this->_getProxyClassCode($r);
//                                     
 //               
 eval($evalStr);
//                         
 eval("\$proxy = new soap_proxy_$r('');");
//                                                                                
 $proxy->endpointType = 'wsdl';
$proxy->wsdlFile = $this->wsdlFile;
$proxy->wsdl = $this->wsdl;
$proxy->operations = $this->operations;
$proxy->defaultRpcParams = $this->defaultRpcParams;
//                     
 $proxy->username = $this->username;
$proxy->password = $this->password;
$proxy->authtype = $this->authtype;
$proxy->proxyhost = $this->proxyhost;
$proxy->proxyport = $this->proxyport;
$proxy->proxyusername = $this->proxyusername;
$proxy->proxypassword = $this->proxypassword;
$proxy->timeout = $this->timeout;
$proxy->response_timeout = $this->response_timeout;
$proxy->http_encoding = $this->http_encoding;
$proxy->persistentConnection = $this->persistentConnection;
$proxy->requestHeaders = $this->requestHeaders;
$proxy->soap_defencoding = $this->soap_defencoding;
$proxy->endpoint = $this->endpoint;
$proxy->forceEndpoint = $this->forceEndpoint;
return $proxy;
}

/**
 *                                     
 *
 *                     /                               
 *                  
 */
function _getProxyClassCode($r) {
if ($this->endpointType != 'wsdl') {
$evalStr = 'A proxy can only be created for a WSDL client';
$this->setError($evalStr);
return $evalStr;
}
$evalStr = '';
foreach ($this->operations as $operation => $opData) {
if ($operation != '') {
//                                             
 if (sizeof($opData['input']['parts']) > 0) {
$paramStr = '';
$paramArrayStr = '';
$paramCommentStr = '';
foreach ($opData['input']['parts'] as $name => $type) {
$paramStr .= "\$$name, ";
$paramArrayStr .= "'$name' => \$$name, ";
$paramCommentStr .= "$type \$$name, ";
}
$paramStr = substr($paramStr, 0, strlen($paramStr)-2);
$paramArrayStr = substr($paramArrayStr, 0, strlen($paramArrayStr)-2);
$paramCommentStr = substr($paramCommentStr, 0, strlen($paramCommentStr)-2);
} else {
$paramStr = '';
$paramCommentStr = 'void';
}
$opData['namespace'] = !isset($opData['namespace']) ? 'http://testuri.com' : $opData['namespace'];
$evalStr .= "// $paramCommentStr
	function " . str_replace('.', '__', $operation) . "($paramStr) {
		\$params = array($paramArrayStr);
		return \$this->call('$operation', \$params, '".$opData['namespace']."', '".(isset($opData['soapAction']) ? $opData['soapAction'] : '')."');
	}
	";
unset($paramStr);
unset($paramCommentStr);
}
}
$evalStr = 'class soap_proxy_'.$r.' extends soapclient {
	'.$evalStr.'
}';
return $evalStr;
}

/**
 *                                     
 *
 *                     /                               
 *                 
 */
function getProxyClassCode() {
$r = rand();
return $this->_getProxyClassCode($r);
}

/**
 *                                            
 *
 *                                        
 *                                                              
 *                
 */
function getHTTPBody($soapmsg) {
return $soapmsg;
}

/**
 *                                                    
 *
 *                                              
 *
 *                                                              
 *                
 */
function getHTTPContentType() {
return 'text/xml';
}

/**
 *                                                            
 *                                          
 *
 *                                              
 *
 *                                                                      
 *                
 */
function getHTTPContentTypeCharset() {
return $this->soap_defencoding;
}

/*
 *                                                         
    *
    *                              
    *                 
    */
function decodeUTF8($bool){
$this->decode_utf8 = $bool;
return true;
}

/**
  *                                            
  *
  *                                
  *                                  
  *                                                              
  *               
  */
function setCookie($name, $value) {
if (strlen($name) == 0) {
return false;
}
$this->cookies[] = array('name' => $name, 'value' => $value);
return true;
}

/**
  *                 
  *
  *                                          
  *                 
  */
function getCookies() {
return $this->cookies;
}

/**
  *                                                      
  *
  *                             
  *                  
  */
function checkCookies() {
if (sizeof($this->cookies) == 0) {
return true;
}
$this->debug('checkCookie: check ' . sizeof($this->cookies) . ' cookies');
$curr_cookies = $this->cookies;
$this->cookies = array();
foreach ($curr_cookies as $cookie) {
if (! is_array($cookie)) {
$this->debug('Remove cookie that is not an array');
continue;
}
if ((isset($cookie['expires'])) && (! empty($cookie['expires']))) {
if (strtotime($cookie['expires']) > time()) {
$this->cookies[] = $cookie;
} else {
$this->debug('Remove expired cookie ' . $cookie['name']);
}
} else {
$this->cookies[] = $cookie;
}
}
$this->debug('checkCookie: '.sizeof($this->cookies).' cookies left in array');
return true;
}

/**
  *                                           
  *
  *                                                                    
  *                           
  *                
  */
function UpdateCookies($cookies) {
if (sizeof($this->cookies) == 0) {
//                                          
 if (sizeof($cookies) > 0) {
$this->debug('Setting new cookie(s)');
$this->cookies = $cookies;
}
return true;
}
if (sizeof($cookies) == 0) {
//                                    
 return true;
}
//      
 foreach ($cookies as $newCookie) {
if (!is_array($newCookie)) {
continue;
}
if ((!isset($newCookie['name'])) || (!isset($newCookie['value']))) {
continue;
}
$newName = $newCookie['name'];

$found = false;
for ($i = 0; $i < count($this->cookies); $i++) {
$cookie = $this->cookies[$i];
if (!is_array($cookie)) {
continue;
}
if (!isset($cookie['name'])) {
continue;
}
if ($newName != $cookie['name']) {
continue;
}
$newDomain = isset($newCookie['domain']) ? $newCookie['domain'] : 'NODOMAIN';
$domain = isset($cookie['domain']) ? $cookie['domain'] : 'NODOMAIN';
if ($newDomain != $domain) {
continue;
}
$newPath = isset($newCookie['path']) ? $newCookie['path'] : 'NOPATH';
$path = isset($cookie['path']) ? $cookie['path'] : 'NOPATH';
if ($newPath != $path) {
continue;
}
$this->cookies[$i] = $newCookie;
$found = true;
$this->debug('Update cookie ' . $newName . '=' . $newCookie['value']);
break;
}
if (! $found) {
$this->debug('Add cookie ' . $newName . '=' . $newCookie['value']);
$this->cookies[] = $newCookie;
}
}
return true;
}
}
?>
