<?php

//                                 
class ScheduleType
{
function buildForm( $jobId = 0 ){}
function getName() {}
function getShortSummary() {}

/**
  *                             
  * 
  *                                                              
  * 
  *                                                                        
  **/
function getRelations() {}

/**
  *                            
  *                                   
  * 
  *         
  **/
function loadGlobals() {}

/**
  *                        
  * 
  *                                                      
  **/
function getData() {}

/**
  *                         
  * 
  *                                          
  * 
  *                                                                   
  *             
  **/
function loadData( $data ) {}

/**
  *                           
  * 
  *                                   
  * 
  *         
  **/
function setGlobals() {}
/**
  *                      
  * 
  *                                                                              
  *                                                                                      
  *                                                                       
  *                                                                                                   
  *                                                                                                          
  *                                                                     
  **/
function isDue( $time, $lastrun, $jobId, $previousJobIds ) {} 

/**
  *                      
  *                                                                  
  *                                                                                          
  *                       
  *             
  **/
function start() {}
/**
  *                       
  *                                                                   
  *                                                                                          
  *                       
  *             
  **/
function finished() {}

/**
  *                       
  * 
  *                                                                      
  * 
  *                
  *             
  *                                                                                              
  *                
  **/
function isDone( $time, $lastRun, $id, $previousJobs ) {} 

/**
  *                           
  * 
  *                                                                                  
  **/
function getActions() {}
/**
  *                              
  * 
  *                                                  
  *         
  **/
function performAction( $action ) {}
}


class ScheduleTypeTime extends ScheduleType
{
var $d_timeStamp, $d_runNext;

function buildForm( $jobId = 0 )
{
global $HI, $DIC;

$f = $HI["date"];
$f["label"] = $DIC[1194];
$f["var"] = "sDate";
$hi[] = $f;
$f = $HI["time"];
$f["label"] = $DIC[1195];
$f["var"] = "sTime";
$hi[] = $f;

return $hi;
}

function isDue( $time, $lastRun, $jobId, $previousJobIds )
{
if ( $this->d_runNext )
return true;
return $time > $this->d_timeStamp && !$lastRun;
}

function getName()
{
global $DIC;
return $DIC[1558];
}

function getShortSummary() 
{
return date( "d-m-Y H:i", $this->d_timeStamp );
}

function setGlobals()
{
global $sDate, $sTime;
$sDate = $sTime = $this->d_timeStamp;
}

function loadData( $data )
{
$this->d_timeStamp = $data["timeStamp"];
$this->d_runNext = $data["runnext"];
}


function loadGlobals()
{
global $sDate, $sTime;
node_include( "datestring2ts" );
$this->d_timeStamp = merge_date_time( $sDate, $sTime );
}

function getData()
{
node_include( "datestring2ts" );
$data = array(
"timeStamp" => $this->d_timeStamp,
"runnext" => $this->d_runNext
);
return $data;
}

function isDone( $time, $lastRun, $id, $previousJobs ) 
{
if ( $this->d_runNext )
return false;
return $lastRun != 0;
}


function getActions()
{   
global $DIC;

if (perm($USER_ID, T_TASKADMIN, "", 13)) {
return array(
array( "key"=>"runnow", "descr"=>$DIC[1559] )
);
} else {
return array();
}
}


function performAction( $action )
{   
switch ( $action )
{   
case "runnow":
$this->d_runNext = true;
break;
}
}

function finished()
{   
if ( $this->d_runNext )
$this->d_runNext = false;
}


}

class ScheduleTypeInterval extends ScheduleType
{
var $d_start, $d_end, $d_every,$d_scale, $d_runNext;

function buildForm( $jobId = 0 )
{
global $HI, $DIC;

$f = $HI["date"];
$f["label"] = $DIC[1098];
$f["optional"] = true;
$f["var"] = "sStartDate";
$hi[] = $f;
$f = $HI["time"];
$f["label"] = $DIC[1562];
$f["optional"] = true;
$f["allow_empty"] = true;
$f["var"] = "sStartTime";
$f["nobreak"] = true;
$hi[] = $f;
$f = $HI["date"];
$f["label"] =  $DIC[1099];
$f["optional"] = true;
$f["allow_empty"] = true;
$f["var"] = "sEndDate";
$hi[] = $f;
$f = $HI["time"];
$f["label"] = $DIC[1563];
$f["optional"] = true;
$f["allow_empty"] = true;
$f["var"] = "sEndTime";
$f["nobreak"] = true;
$hi[] = $f;

$f = $HI["int"];
$f["label"] = $DIC[415];
$f["var"] = "sEvery";
$f["size"] = 5;
$hi[] = $f;

$f = $HI["sel"];
$f["label"] = "";
$f["var"] = "sScale";
$f["nobreak"] = true;
$f["list"] = array( "min"=>$DIC[1108], "std"=>$DIC[1101], "day"=>$DIC[1564] );//                      
 $hi[] = $f;

return $hi;
}

function _translateScale( $long = false )
{
global $DIC;

switch ( $this->d_scale )
{
case "min":
return $long?$DIC[1108]:$DIC[1567];
case "std":
return $long?$DIC[1101]:$DIC[1566];
case "day":
return $long?$DIC[1564]:$DIC[1565];
}
}

function getInterval()
{
switch ( $this->d_scale )
{
case "min":
$int = 60 * $this->d_every;
break;
case "std":
$int = 60*60 * $this->d_every;
break;
case "day":
$int = 24*60*60 * $this->d_every;
break;
case "month":
halt( 7, "TODO: isDue for months!!!!" );
break;
}
return $int;
}

function isDone( $time, $lastRun, $id, $previousJobs ) 
{
if ( $this->d_runNext )
return false;
if ( !$this->d_end )
return false;
return $lastRun+$this->getInterval() >= $this->d_end || $time >= $this->d_end;
}

/**
  *                                                                 
  *                                 
  *                                                                  
  *                                                               
  *                                                                
  *                                                                
     *                                 
  *                                                                
  */
function _getMostRecentSchedule($time) {
$interval = $this->getInterval();
if ($interval <= 0) {
return false;
}
if ($this->d_scale == "day") {
//                                    
 //                                
 //                                                     
 //                                                      
 //                                                             
 //                                                                 
 //                                
 //                                                     
 //                                                                     
 //                                                                          
 //                                                                       
 //                                      

//                                               
 $days = floor(($time - $this->d_start) / (60*60*24));
//                                                         
 //                                                        
 //                                                          
 //                                
 if (strtotime("+".($days+1)." days", $this->d_start) <= $time) {
$days++;
}
//                                                        
 //                                      
 $number_of_runs = floor($days / $this->d_every);
//                                                          
 $days_until_recent_schedule = $number_of_runs * $this->d_every;
//                                                                   
 //                                      
 return strtotime("+$days_until_recent_schedule days", $this->d_start);
} else {
return $this->d_start + 
(intval(($time - $this->d_start) / $interval) * $interval);
}
}

function isDue( $time, $lastRun, $jobId, $previousJobIds ) {
if ( $this->d_runNext ) {
return true;
}
if ( $this->isDone($time, $lastRun, $jobId, $previousJobIds) ) {
return false;
}

//                                               
 if ( $time < $this->d_start ) {
return false;
}

$mostRecent = $this->_getMostRecentSchedule($time);
if ($mostRecent === false) {
return false;
}
return $lastRun < $mostRecent;
}


function finished()
{
if ( $this->d_runNext )
$this->d_runNext = false;
}

function getActions() 
{
global $DIC;

return array(
array( "key"=>"runnow", "descr"=>$DIC[1559] )
);
}

function performAction( $action )
{
switch ( $action )
{
case "runnow":
$this->d_runNext = true;
break;
}
}	

function getShortSummary() 
{
global $DIC; 

$str = "<table border=0>";
$str .= "<tr><td><b>".$DIC[538].":</b></td><td>".date( "d-m-Y H:i", $this->d_start )."</td></tr>";
$str .= "<tr><td><B>".$DIC[539].":</b></td><td>".($this->d_end?date( "d-m-Y H:i", $this->d_end ):i18n("No limit"))."</td></tr>";
$str .= "<tr><td>".$DIC[415]." </td><td>".$this->d_every." ".$this->_translateScale()."</td></tr>";
$str .= "</table>";
return $str;
}


function getName()
{
global $DIC;
return $DIC[1569];
}

function setGlobals( )
{
global $sStartDate, $sStartTime, $sEndDate, $sEndTime, $sEvery, $sScale;
$sStartDate = $sStartTime = $this->d_start;
$sEndDate = $sEndTime = $this->d_end;
$sEvery = $this->d_every;
$sScale = $this->d_scale;
}

function loadData( $data )
{
$this->d_start = $data["start"];
$this->d_end = $data["end"];
$this->d_every = $data["every"];
$this->d_scale = $data["scale"];
$this->d_runNext = $data["runnext"];
}

function loadGlobals()
{
global $sStartDate, $sStartTime, $sEndDate, $sEndTime, $sEvery, $sScale;
node_include( "datestring2ts" );
if ( !$sStartTime ) {
$sStartTime = mktime( 0,0,0 ); 
}
if ( !$sEndDate && !$sEndTime )
$end = 0; 
else {
if ( !$sEndDate ) $sEndDate = time();
else if ( !$sEndTime ) $sEndTime = mktime( 0,0,0 ); 
$end = merge_date_time( $sEndDate, $sEndTime );
}

$data = array(
"start" => merge_date_time( $sStartDate, $sStartTime ),
"end" => $end,
"every" => $sEvery,
"scale" => $sScale,
);
$this->d_start = $data["start"];
$this->d_end = $data["end"];
$this->d_every = $data["every"];
$this->d_scale = $data["scale"];
}

function getData()
{
node_include( "datestring2ts" );
$data = array(
"start" => $this->d_start,
"end" => $this->d_end,
"every" => $this->d_every,
"scale" => $this->d_scale,
"runnext" => $this->d_runNext
);
return $data;
}
}

class ScheduleTypeFollowup extends ScheduleType
{
var $d_followJobs, $d_jobTable = NULL, $d_runNext = false;

function &_getJobTable()
{
node_class( "sqltable" );
if ( $this->d_jobTable != NULL )
return $this->d_jobTable;
return new SqlTable( "job" );
}

function buildForm( $jobId = 0 )
{
global $HI, $DIC;
$joblist = array();
$ancestors = $this->getJobAncestors($jobId);
if (count($ancestors) == 0) {
$ancestors = array(-1);
}
$res = query(//            
"SELECT j.id, j.name FROM job j LEFT JOIN jobdependency jd ON j.id = jd.jobid " . 
" WHERE jd.depid NOT IN (" . implode(',', sqlf_tl_num_array($ancestors)) . ") OR jd.depid IS NULL GROUP BY j.id");
if ($res['num'] > 0) {
$jobs = $res['arr'];			
foreach ( $jobs as $job ) {
if ( $job['id'] != $jobId &&
!in_array($this->getJobAncestors($job['id']), $ancestors)) {
$joblist[$job['id']] = $job['name'];
}
}
}

$f = $HI["sel"];
$f["force"] = false;
$f["label"] = $DIC[1463];
$f["var"] = "sJob";
$f["size"] = 5;
$f["multiple"] = TRUE;
$f["list"] = $joblist;
$hi[] = $f;

return $hi;
}

/**
  *                                                 
  *                                             
  *                              
  */
function getJobAncestors($jobId) {
if (!$jobId) {
return array();
}
$res = query("SELECT depid FROM jobdependency j where j.jobid = ".sqlf_tl_num($jobId));//            
 $ancestors = array();
if ($res['num'] > 0) {
foreach ($res['arr'] as $k => $v) {
$ancestors[] = $v['depid'];
//                                                                          
//                                         

//                                                                            
//                                                         
//     
 }
}
return $ancestors;
}

function isDone( $time, $lastRun, $id, $previousJobs ) 
{
if ( $this->d_runNext )
return false;
node_class( "sqltable" );
$jobTable = new SqlTable( "job" );
$jobs = $jobTable->findBy( "id", $this->d_followJobs );
if ( $jobs[0] )
{
$status = getJobStatus( $jobs[0], false, array_merge( $previousJobs, array( $id ) ) );
if ( $status == JOBSTATUS_INVALID ) return true;
}
else
return TRUE;

return $status == JOBSTATUS_DONE;	
}


function isDue( $time, $lastRun, $jobId, $previousJobIds )
{
if ( $this->d_runNext )
return TRUE;
//                                                                                             
 if ( !count($previousJobIds) )
return false;
$ret = false;
foreach ( $previousJobIds as $pJob )
{
if ( in_array( $pJob, $this->d_followJobs ) )
{
$ret = true;
}
else if ( $pJob == $jobId )
{
$ret = false;
}
}
return $ret;
}

function finished()
{
if ( $this->d_runNext )
$this->d_runNext = false;
}

function getActions() 
{
global $DIC;

return array(
array( "key"=>"runnow", "descr"=>$DIC[1559] )
);
}

function performAction( $action )
{
switch ( $action )
{
case "runnow":
$this->d_runNext = true;
break;
}
}	

function getRelations()
{
return $this->d_followJobs;
}

function getName()
{
global $DIC;
return $DIC[1560];
}

function getShortSummary()
{
global $DIC;
$jobTable = $this->_getJobTable();
//                             
 $jobs = $jobTable->findBy( "id", $this->d_followJobs, "IN", false, false, true );

$ret = array();
foreach ( $jobs as $job )
{
$ret[] = $job->getValue( "name" );
}
return $DIC[1561].": " . implode( ", ", $ret );
}

function setGlobals()
{
global $sJob;
$sJob = $this->d_followJobs;
}

function loadData( $data )
{
$this->d_followJobs = $data["jobs"];
$this->d_runNext = $data["runnext"];
}

function loadGlobals()
{
global $sJob;
$this->d_followJobs = $sJob;
}

function getData()
{
return array("jobs"=>$this->d_followJobs, "runnext"=>$this->d_runNext);	
}
}


class ScheduleTypeManual extends ScheduleType
{
var $d_runNext = false;

function buildForm( $jobId = 0 )
{
return array();
}

function isDone( $time, $lastRun, $id, $previousJobs ) 
{
return false;
}


function isDue( $time, $lastRun, $jobId, $previousJobIds )
{
return $this->d_runNext;
}


function finished()
{
$this->d_runNext = false;
}

function getActions() 
{
global $DIC;

return array(
array( "key"=>"runnow", "descr"=>$DIC[1559] )
);
}

function performAction( $action )
{
switch ( $action )
{
case "runnow":
$this->d_runNext = true;
break;
}
}	

function getName()
{
global $DIC;
return $DIC[1568];
}

function loadData( $data )
{
$this->d_runNext = $data;
}

function getData()
{
return $this->d_runNext;
}
}



global $scheduleTypeClasses;
$scheduleTypeClasses = array(
"time" => new ScheduleTypeTime(),
"int" => new ScheduleTypeInterval(),
"followup" => new ScheduleTypeFollowup(),
"manual" => new ScheduleTypeManual()
);


?>
